Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/prolog/OoaPrologIdentifier.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/prolog/OoaPrologIdentifier.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/prolog/OoaPrologIdentifier.java	(revision 9)
@@ -31,7 +31,6 @@
 import org.momut.ooas.ast.identifiers.EnumIdentifier;
 import org.momut.ooas.ast.identifiers.ExpressionVariableIdentifier;
 import org.momut.ooas.ast.identifiers.Identifier;
-import org.momut.ooas.ast.identifiers.LandmarkIdentifier;
 import org.momut.ooas.ast.identifiers.LocalVariableIdentifier;
 import org.momut.ooas.ast.identifiers.MethodIdentifier;
 import org.momut.ooas.ast.identifiers.NamedActionIdentifier;
@@ -53,11 +52,6 @@
 
 	OoasCodeEmitter m_emitter;
 
-	private void AddTokenText(Identifier anId)
-	{
-		m_emitter.Append(anId.tokenText());
-	}
-
 	private String getUniquePostFix(Identifier id) {
 		return (id.line() > 0) && (id.column()>0)
 				? String.format("%s_%s", id.line(), id.column())
@@ -65,7 +59,7 @@
 	}
 
 	@Override
-	public /*override*/ void visit(EnumIdentifier enumIdentifier)
+	public void visit(EnumIdentifier enumIdentifier)
 	{
 		assert(false); // handled in visit(IdentifierExpression identifierExpression)
 		//AddTokenText(enumIdentifier);
@@ -72,27 +66,20 @@
 	}
 
 	@Override
-	public /*override*/ void visit(LandmarkIdentifier landmarkIdentifier)
+	public void visit(AttributeIdentifier attributeIdentifier)
 	{
-		AddTokenText(landmarkIdentifier);
-	}
-
-	@Override
-	public /*override*/ void visit(AttributeIdentifier attributeIdentifier)
-	{
 		m_emitter.Append(String.format("attr_%s_%s", attributeIdentifier.tokenText(), getUniquePostFix(attributeIdentifier)));
 	}
 
 	@Override
-	public /*override*/ void visit(ExpressionVariableIdentifier expressionVariableIdentifier)
+	public void visit(ExpressionVariableIdentifier expressionVariableIdentifier)
 	{
 		m_emitter.Append(String.format("ExprVar_%s_%s", expressionVariableIdentifier, getUniquePostFix(expressionVariableIdentifier)));
 	}
 
 	@Override
-	public /*override*/ void visit(ParameterIdentifier parameterIdentifier)
+	public void visit(ParameterIdentifier parameterIdentifier)
 	{
-		//m_emitter.Append(parameterIdentifier.tokenText().ToUpper());
 		if (parameterIdentifier.tokenText().equals("result"))
 			m_emitter.Append("RESULT"); // methods are transformed into their own predicates, so they have their own scope..
 		else
@@ -100,7 +87,7 @@
 	}
 
 	@Override
-	public /*override*/ void visit(LocalVariableIdentifier localVariableIdentifier)
+	public void visit(LocalVariableIdentifier localVariableIdentifier)
 	{
 		m_emitter.Append(String.format("_%s_%s",
 				localVariableIdentifier.tokenText(), getUniquePostFix(localVariableIdentifier)));
@@ -107,7 +94,7 @@
 	}
 
 	@Override
-	public /*override*/ void visit(TypeIdentifier typeIdentifier)
+	public void visit(TypeIdentifier typeIdentifier)
 	{
 		switch (typeIdentifier.type().kind())
 		{
@@ -161,13 +148,13 @@
 	}
 
 	@Override
-	public /*override*/ void visit(MethodIdentifier methodIdentifier)
+	public void visit(MethodIdentifier methodIdentifier)
 	{
 		m_emitter.Append(String.format("'%s'", methodIdentifier.tokenText()));
 	}
 
 	@Override
-	public /*override*/ void visit(NamedActionIdentifier namedActionIdentifier)
+	public void visit(NamedActionIdentifier namedActionIdentifier)
 	{
 		m_emitter.Append(String.format("'%s'", namedActionIdentifier.tokenText()));
 	}
@@ -174,7 +161,7 @@
 
 
 	@Override
-	public /*override*/ String toString()
+	public String toString()
 	{
 		return m_emitter.toString();
 	}
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/prolog/OoaPrologExpression.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/prolog/OoaPrologExpression.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/prolog/OoaPrologExpression.java	(revision 9)
@@ -40,7 +40,6 @@
 import org.momut.ooas.ast.expressions.ListConstructor;
 import org.momut.ooas.ast.expressions.MapConstructor;
 import org.momut.ooas.ast.expressions.ObjectConstructor;
-import org.momut.ooas.ast.expressions.QValConstructor;
 import org.momut.ooas.ast.expressions.SetConstructor;
 import org.momut.ooas.ast.expressions.TernaryOperator;
 import org.momut.ooas.ast.expressions.TupleConstructor;
@@ -52,11 +51,10 @@
 import org.momut.ooas.ast.identifiers.EnumIdentifier;
 import org.momut.ooas.ast.identifiers.Identifier;
 import org.momut.ooas.ast.identifiers.IdentifierKind;
-import org.momut.ooas.ast.identifiers.LandmarkIdentifier;
 import org.momut.ooas.ast.types.EnumType;
 import org.momut.ooas.ast.types.FunctionType;
 import org.momut.ooas.ast.types.TypeKind;
-import org.momut.ooas.ast.types.UlyssesType;
+import org.momut.ooas.ast.types.Type;
 import org.momut.ooas.ast.types.ValuedEnumType;
 import org.momut.ooas.codegen.OoasCodeEmitter;
 import org.momut.ooas.utils.exceptions.ArgumentException;
@@ -106,7 +104,7 @@
 
 	// call of method that returns a value..
 	@Override
-	public /*override*/ void visit(CallExpression callExpression)
+	public void visit(CallExpression callExpression)
 	{
 		// we handle only function calls within expressions here (must have non-void return!)
 		final FunctionType funtype = (FunctionType)callExpression.child().type();
@@ -141,7 +139,7 @@
 
 
 	// we need to map all other things to Prolog constructs
-	private String OperatorString(Expression expression, UlyssesType resultingType)
+	private String OperatorString(Expression expression, Type resultingType)
 	{
 		switch (expression.kind())
 		{
@@ -232,7 +230,7 @@
 
 	@SuppressWarnings("unchecked")
 	@Override
-	public /*override*/ <T> void visit(ValueExpression<T> valueExpression)
+	public <T> void visit(ValueExpression<T> valueExpression)
 	{
 		assert(m_tmpVars.size() == 0);
 		final String tmpVar = NewTempVariable();
@@ -255,19 +253,10 @@
 	}
 
 	@Override
-	public /*override*/ void visit(IdentifierExpression identifierExpression)
+	public void visit(IdentifierExpression identifierExpression)
 	{
-		if (identifierExpression.identifier().kind() == IdentifierKind.LandmarkIdentifier)
+		if (identifierExpression.identifier().kind() == IdentifierKind.EnumIdentifier)
 		{
-			final LandmarkIdentifier lmid = (LandmarkIdentifier)identifierExpression.identifier();
-			final OoaPrologIdentifier pid = createIdentifierVisitor();
-			lmid.Accept(pid);
-			//m_emitter.Append(pid.ToString());
-			m_tmpVars.add(pid.toString());
-			return;
-		}
-		else if (identifierExpression.identifier().kind() == IdentifierKind.EnumIdentifier)
-		{
 			final EnumIdentifier enumid = (EnumIdentifier)identifierExpression.identifier();
 			final EnumType enumType = (EnumType)enumid.type();
 			//m_emitter.Append(enumType.listOfEnumSymbols.IndexOf(enumid));
@@ -281,9 +270,9 @@
 			m_emitter.AppendLine(String.format("%s = %s,", NewTempVariable(), GetIdentifierString(identifierExpression.identifier())));
 		}
 		/*else if (identifierExpression.identifier.kind == IdentifierKind.AttributeIdentifier)
-        {
-            m_emitter.AppendLine(String.format("getVal(%s,%s,_),", GetIdentifierString(identifierExpression.identifier), NewTempVariable(), ));
-        }*/
+		{
+			m_emitter.AppendLine(String.format("getVal(%s,%s,_),", GetIdentifierString(identifierExpression.identifier), NewTempVariable(), ));
+		}*/
 		else
 		{
 			m_tmpVars.add(GetIdentifierString(identifierExpression.identifier()));
@@ -291,7 +280,7 @@
 	}
 
 	@Override
-	public /*override*/ void visit(TypeExpression typeExpression)
+	public void visit(TypeExpression typeExpression)
 	{
 		if (typeExpression.type().kind() != TypeKind.QrType &&
 				typeExpression.type().kind() != TypeKind.EnumeratedType)
@@ -302,7 +291,7 @@
 
 
 	@Override
-	public /*override*/ void visit(ObjectConstructor objectConstructor)
+	public void visit(ObjectConstructor objectConstructor)
 	{
 		if (objectConstructor.instances().size() > 1)
 			throw new NotImplementedException();
@@ -313,7 +302,7 @@
 	}
 
 	@Override
-	public /*override*/ void visit(ListConstructor listConstructor)
+	public void visit(ListConstructor listConstructor)
 	{
 		if (listConstructor.hasComprehension())
 		{
@@ -363,7 +352,7 @@
 	}
 
 	@Override
-	public /*override*/ void visit(SetConstructor setConstructor)
+	public void visit(SetConstructor setConstructor)
 	{
 		m_emitter.AppendLine("% make set");
 		// our resulting set.
@@ -385,13 +374,13 @@
 	}
 
 	@Override
-	public /*override*/ void visit(MapConstructor mapConstructor)
+	public void visit(MapConstructor mapConstructor)
 	{
 		throw new NotImplementedException();
 	}
 
 	@Override
-	public /*override*/ void visit(TupleConstructor tupleConstructor)
+	public void visit(TupleConstructor tupleConstructor)
 	{
 		if (tupleConstructor.isMatcher())
 		{
@@ -421,50 +410,8 @@
 	}
 
 	@Override
-	public /*override*/ void visit(QValConstructor qValConstructor)
+	public void visit(AccessExpression accessExpression)
 	{
-		final OoaPrologIdentifier pident = createIdentifierVisitor();
-		qValConstructor.type().identifier().Accept(pident);
-		final StringBuilder qVal = new StringBuilder();
-		if (qValConstructor.value() != null || qValConstructor.value().length != 0)
-		{
-			final OoaPrologExpression landmark1 = createExpressionVisitor();
-			qValConstructor.value()[0].Accept(landmark1);
-			qVal.append(landmark1.toString());
-
-			if (qValConstructor.value().length > 1)
-			{
-				final OoaPrologExpression landmark2 = createExpressionVisitor();
-				qValConstructor.value()[1].Accept(landmark2);
-				qVal.append("..");
-				qVal.append(landmark2.toString());
-			}
-		}
-		else
-			qVal.append("_");
-
-		String deriv = "_";
-		switch (qValConstructor.valueDeriv())
-		{
-		case Dec:
-			deriv = "dec";
-			break;
-		case Inc:
-			deriv = "inc";
-			break;
-		case Steady:
-			deriv = "std";
-			break;
-		default:
-			throw new NotImplementedException();
-		}
-		final String tmpVar = NewTempVariable();
-		m_emitter.AppendLine(String.format("%s = (%s:%s/%s),", tmpVar, pident.toString(), qVal.toString(), deriv));
-	}
-
-	@Override
-	public /*override*/ void visit(AccessExpression accessExpression)
-	{
 		if (accessExpression.left().type().kind() != TypeKind.QrType &&
 				accessExpression.left().type().kind() != TypeKind.EnumeratedType &&
 				!(accessExpression.right().kind() == ExpressionKind.Identifier &&
@@ -485,7 +432,7 @@
 	}
 
 	@Override
-	public /*override*/ void visit(BinaryOperator binaryOperator)
+	public void visit(BinaryOperator binaryOperator)
 	{
 		final OoasCodeEmitter origEmitter = m_emitter;
 
@@ -610,7 +557,7 @@
 	}
 
 	@Override
-	public /*override*/ void visit(TernaryOperator ternaryOperator)
+	public void visit(TernaryOperator ternaryOperator)
 	{
 		if (ternaryOperator.kind() == ExpressionKind.conditional)
 		{
@@ -666,7 +613,7 @@
 	}
 
 	@Override
-	public /*override*/ void visit(TupleMapAccessExpression tupleMapAccessExpression)
+	public void visit(TupleMapAccessExpression tupleMapAccessExpression)
 	{
 		assert(m_tmpVars.size() == 0);
 		VisitSub(tupleMapAccessExpression.child(), tupleMapAccessExpression);
@@ -734,7 +681,7 @@
 
 
 	@Override
-	public /*override*/ void visit(ForallQuantifier quantifier)
+	public void visit(ForallQuantifier quantifier)
 	{
 		final OoaPrologExpression pExpr = createExpressionVisitor();
 		quantifier.child().Accept(pExpr);
@@ -764,7 +711,7 @@
 
 
 	@Override
-	public /*override*/ void visit(ExistsQuantifier quantifier)
+	public void visit(ExistsQuantifier quantifier)
 	{
 		final OoaPrologExpression pExpr = createExpressionVisitor();
 		quantifier.child().Accept(pExpr);
@@ -791,7 +738,7 @@
 				NewTempVariable(), Generator.toString(), nullGuard.toString(), pExpr.toString(), pExpr.tmpVariables().get(0)));
 	}
 	@Override
-	public /*override*/ void visit(UnaryOperator unaryOperator)
+	public void visit(UnaryOperator unaryOperator)
 	{
 		assert(m_tmpVars.size() == 0);
 		VisitSub(unaryOperator.child(), unaryOperator);
@@ -849,7 +796,7 @@
 	}
 
 	@Override
-	public /*override*/ String toString()
+	public String toString()
 	{
 		return m_emitter.toString();
 	}
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/identifiers/Scope.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/identifiers/Scope.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/identifiers/Scope.java	(revision 9)
@@ -29,7 +29,7 @@
 
 import org.antlr.runtime.Token;
 import org.momut.ooas.ast.IScope;
-import org.momut.ooas.ast.types.UlyssesType;
+import org.momut.ooas.ast.types.Type;
 import org.momut.ooas.parser.SymbolTable;
 
 ///////////////////////////////////////////////
@@ -40,7 +40,7 @@
 	protected SymbolTable m_symbolTable;
 
 	public Scope(Token aToken,
-			UlyssesType aType,
+			Type aType,
 			IdentifierKind aKind,
 			IScope aDefiningScope)
 	{
@@ -50,7 +50,7 @@
 
 
 	public Scope(String aName,
-			UlyssesType aType,
+			Type aType,
 			IdentifierKind aKind,
 			IScope aDefiningScope)
 	{
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/identifiers/SelfTypeIdentifier.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/identifiers/SelfTypeIdentifier.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/identifiers/SelfTypeIdentifier.java	(revision 9)
@@ -29,12 +29,12 @@
 
 import org.momut.ooas.ast.IAstVisitor;
 import org.momut.ooas.ast.IScope;
-import org.momut.ooas.ast.types.UlyssesType;
+import org.momut.ooas.ast.types.Type;
 
 public final class SelfTypeIdentifier extends TypeIdentifier
 {
 	public SelfTypeIdentifier(String aName,
-			UlyssesType aType,
+			Type aType,
 			IScope aDefiningScope)
 	{
 		super (aName, aType, aDefiningScope);
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/identifiers/TypeIdentifier.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/identifiers/TypeIdentifier.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/identifiers/TypeIdentifier.java	(revision 9)
@@ -30,7 +30,7 @@
 import org.antlr.runtime.Token;
 import org.momut.ooas.ast.IAstVisitor;
 import org.momut.ooas.ast.IScope;
-import org.momut.ooas.ast.types.UlyssesType;
+import org.momut.ooas.ast.types.Type;
 
 ///////////////////////////////////////////////
 ///  Type Identifier
@@ -41,7 +41,7 @@
 	public String prefix = "";
 
 	protected TypeIdentifier(Token aToken,
-			UlyssesType aType,
+			Type aType,
 			IdentifierKind someKind,
 			IScope aDefiningScope)
 	{
@@ -49,7 +49,7 @@
 	}
 
 	protected TypeIdentifier(String aToken,
-			UlyssesType aType,
+			Type aType,
 			IdentifierKind someKind,
 			IScope aDefiningScope)
 	{
@@ -58,7 +58,7 @@
 
 
 	public TypeIdentifier(Token aToken,
-			UlyssesType aType,
+			Type aType,
 			IScope aDefiningScope)
 	{
 		super (aToken, aType, IdentifierKind.TypeIdentifier, aDefiningScope);
@@ -66,7 +66,7 @@
 
 
 	public TypeIdentifier(String aName,
-			UlyssesType aType,
+			Type aType,
 			IScope aDefiningScope)
 	{
 		super (aName, aType, IdentifierKind.TypeIdentifier, aDefiningScope);
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/identifiers/ValueIdentifier.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/identifiers/ValueIdentifier.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/identifiers/ValueIdentifier.java	(revision 9)
@@ -30,7 +30,7 @@
 
 import org.antlr.runtime.Token;
 import org.momut.ooas.ast.IScope;
-import org.momut.ooas.ast.types.UlyssesType;
+import org.momut.ooas.ast.types.Type;
 
 ///////////////////////////////////////////////
 ///  Value Identifiers
@@ -37,7 +37,7 @@
 ///
 public abstract class ValueIdentifier extends Identifier {
 	public ValueIdentifier(Token aToken,
-			UlyssesType aType,
+			Type aType,
 			IdentifierKind aKind,
 			IScope aDefiningScope)
 	{
@@ -45,7 +45,7 @@
 	}
 
 	public ValueIdentifier(String name,
-			UlyssesType aType,
+			Type aType,
 			IdentifierKind aKind,
 			IScope aDefiningScope)
 	{
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/identifiers/ValueReferenceIdentifier.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/identifiers/ValueReferenceIdentifier.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/identifiers/ValueReferenceIdentifier.java	(revision 9)
@@ -29,7 +29,7 @@
 
 import org.antlr.runtime.Token;
 import org.momut.ooas.ast.IScope;
-import org.momut.ooas.ast.types.UlyssesType;
+import org.momut.ooas.ast.types.Type;
 
 ///////////////////////////////////////////////
 ///  Variable Identifiers
@@ -38,7 +38,7 @@
 public abstract class ValueReferenceIdentifier extends Identifier
 {
 	public ValueReferenceIdentifier(Token aToken,
-			UlyssesType aType,
+			Type aType,
 			IdentifierKind aKind,
 			IScope aDefiningScope)
 	{
@@ -50,7 +50,7 @@
 		super(toCopy);
 	}
 
-	public ValueReferenceIdentifier(String name, UlyssesType aType, IdentifierKind aKind, IScope aDefiningScope)
+	public ValueReferenceIdentifier(String name, Type aType, IdentifierKind aKind, IScope aDefiningScope)
 	{
 		super(name, aType, aKind, aDefiningScope);
 	}
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/statements/StatementKind.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/statements/StatementKind.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/statements/StatementKind.java	(revision 9)
@@ -38,7 +38,7 @@
 	Skip(6),
 	Abort(7),
 	Kill(8),
-	QualConstraint(9),
+//	QualConstraint(9),  // no longer supported
 	Break (10);
 
 	public final int integerValue; // do not change, this is needed by the backends! i.e. public API
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/AnyType.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/AnyType.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/AnyType.java	(revision 9)
@@ -33,7 +33,7 @@
 ///////////////////////////////////////////////
 ///  Special type: any  (used for free variables)
 ///
-public final class AnyType extends UlyssesType
+public final class AnyType extends Type
 {
 	private final ExpressionVariableIdentifier m_variableIdentifier;
 
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/BoolType.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/BoolType.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/BoolType.java	(revision 9)
@@ -33,7 +33,7 @@
 ///////////////////////////////////////////////
 ///  Simple Type: Bool
 ///
-public final class BoolType extends UlyssesType
+public final class BoolType extends Type
 {
 	public BoolType(TypeIdentifier anIdentifier)
 	{
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/FloatType.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/FloatType.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/FloatType.java	(revision 9)
@@ -33,7 +33,7 @@
 ///////////////////////////////////////////////
 ///  Simple Type: Float (fixed point)
 ///
-public final class FloatType extends UlyssesType
+public final class FloatType extends Type
 {
 	private final double m_low;
 	private final double m_high;
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/IntType.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/IntType.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/IntType.java	(revision 9)
@@ -33,7 +33,7 @@
 ///////////////////////////////////////////////
 ///  Simple Type: Int
 ///
-public class IntType extends UlyssesType
+public class IntType extends Type
 {
 	protected int m_low;
 	protected int m_high;
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/MapType.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/MapType.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/MapType.java	(revision 9)
@@ -34,17 +34,17 @@
 ///////////////////////////////////////////////
 ///  Complex Type: Map
 ///
-public final class MapType extends UlyssesType
+public final class MapType extends Type
 {
-	private UlyssesType m_fromType;
-	private UlyssesType m_toType;
+	private Type m_fromType;
+	private Type m_toType;
 	private final int m_maxNumberOfElements;
 
-	public UlyssesType fromType() { return m_fromType; }
-	public UlyssesType toType() { return m_toType; }
+	public Type fromType() { return m_fromType; }
+	public Type toType() { return m_toType; }
 	public int maxNumberOfElements() { return m_maxNumberOfElements; }
 
-	public MapType(UlyssesType from, UlyssesType to, int max, TypeIdentifier anIdentifier)
+	public MapType(Type from, Type to, int max, TypeIdentifier anIdentifier)
 	{
 		super(TypeKind.MapType, anIdentifier);
 		m_fromType = from;
@@ -58,7 +58,7 @@
 		visitor.visit(this);
 	}
 
-	public void SetFromType(UlyssesType newType)
+	public void SetFromType(Type newType)
 	{
 		if (newType == null)
 			throw new ArgumentException();
@@ -65,7 +65,7 @@
 		m_fromType = newType;
 	}
 
-	public void SetToType(UlyssesType newType)
+	public void SetToType(Type newType)
 	{
 		if (newType == null)
 			throw new ArgumentException();
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/OoActionSystemType.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/OoActionSystemType.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/OoActionSystemType.java	(revision 9)
@@ -38,7 +38,7 @@
 import org.momut.ooas.utils.exceptions.ArgumentException;
 import org.momut.ooas.utils.exceptions.InternalCompilerException;
 
-public class OoActionSystemType extends UlyssesType implements IScope
+public class OoActionSystemType extends Type implements IScope
 {
 	private final boolean m_autoCons;
 	private OoActionSystemType m_baseType;
